package com.dsk.cscec.domain;

import com.baomidou.mybatisplus.annotation.TableId;
import com.dsk.common.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * 项目台账表(CbProjectRecord)实体类
 *
 * @author sxk
 * @since 2024-02-05 11:37:52
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class CbProjectRecord extends BaseEntity implements Serializable {
    private static final long serialVersionUID = 380419400445207916L;
    /**
     * 主键ID
     */
    @TableId(value = "id")
    private Long id;
    /**
     * 成本阶段(0:标前成本、1:标后成本、2:转固成本)
     */
    private Integer cbStage;
    /**
     * 项目名称
     */
    private String projectName;
    /**
     * 项目文件状态(0:待解析、1:解析中、2:解析成功、3:解析失败)
     */
    private Integer projectFileStatus;
    /**
     * IPM项目编码
     */
    private String ipmProjectNo;
    /**
     * 文件名称
     */
    private String projectFileName;
    /**
     * 删除状态(0:否、2:是)
     */
    private Integer delFlag;
}
