package com.dsk.cscec.domain;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;

import lombok.Data;

/**
 * 成本-工料汇总基本表(CbQuantitySummary)表实体类
 *
 * @author lcl
 * @since 2024-02-05 11:06:56
 */
@Data
@TableName("cb_quantity_summary")
public class CbQuantitySummary implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id")
    private Long id;
    /**
     * 项目id
     */
    private Long projectId;
    /**
     * 序号
     */
    private String number;
    /**
     * 成本阶段(0：标前成本 1：标后成本 2：转固成本)
     */
    private Integer cbStage;
    /**
     * 成本科目名称（合约规划）
     */
    private String cbSubjectName;
    /**
     * 成本科目编号（合约规划编号）
     */
    private String cbSubjectNo;
    /**
     * 公司编码
     */
    private String companyNo;
    /**
     * 集团编码
     */
    private String orgNo;
    /**
     * 成本名称
     */
    private String cbName;
    /**
     * 工作内容
     */
    private String jobContent;
    /**
     * 计算规则
     */
    private String calculationRule;
    /**
     * 计量单位
     */
    private String unit;
    /**
     * 材料说明
     */
    private String materialDescription;
    /**
     * 指导价格
     */
    private String guidePrice;
    /**
     * 投标选用单价（不含税）
     */
    private Double bidUnitPrice;
    /**
     * 单价差额
     */
    private Double unitPriceDifference;
    /**
     * 数量
     */
    private Double quantity;
    /**
     * 合价（不含税）
     */
    private Double combinedPrice;
    /**
     * 合价（含税）
     */
    private Double combinedPriceTax;
    /**
     * 品牌名称
     */
    private String brandName;
    /**
     * 投标选用来源
     */
    private String bidSource;
    /**
     * 备注
     */
    private String remark;
    /**
     * 创建时间
     */
    private Date createTime;

}

